stages:
  - lint
  - build
  - deploy

lint:
  stage: lint
  image:
    name: golangci/golangci-lint
    entrypoint: [""]
  script:
    - golangci-lint run
  allow_failure: true

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.9.0-debug
    entrypoint: [""]
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}-${CI_COMMIT_SHORT_SHA}"

deploy:
  stage: deploy
  script:
    - docker stop go-example || true
    - docker rm go-example || true
    - docker run -d --name go-example --pull always -p 80:8080 ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}-${CI_COMMIT_SHORT_SHA}
  tags:
    - active-runner